//////////////////////////////////////////////////////////////////////////////
//	NX
//////////////////////////////////////////////////////////////////////////////

#pragma once

#include "acbase.h"

#include <vector>
#include <string>
#include <boost/tokenizer.hpp>

#include "Config.h"
#include "string_ex.h"

class CAutoCreate
{
public:
	// RXgN^
	CAutoCreate( AC_PCPICTUREINFO pPictureInfo, CConfig * pConfig ):
		m_attNameVec()
	{
		if ( !( pPictureInfo->state & AC_PISB_FILEPATH ) )
			throw std::exception() ;
		char	dir[_MAX_DIR] ;
		::_splitpath( pPictureInfo->pszFilePath, NULL, dir, NULL, NULL ) ;
		std::wstring	wstrDir ;
		MakeWString( wstrDir, dir ) ;
		typedef boost::char_separator<wchar_t>	Separator ;
		typedef boost::tokenizer<Separator,std::wstring::const_iterator,std::wstring>	Tokenizer ;
		Tokenizer	tokens( wstrDir, Separator(L"\\") ) ;
		for ( Tokenizer::iterator itr = tokens.begin() ; itr != tokens.end() ; ++ itr )
		{
			if ( pConfig->IsValidName( itr->c_str() ) )
			{
				std::string	attName ;
				MakeString( attName, itr->c_str() ) ;
				m_attNameVec.push_back( attName.c_str() ) ;
			}
		}
		if ( m_attNameVec.empty() )
			throw std::exception() ;
	}

private:
	std::vector<std::string>	m_attNameVec ;

public:
	// ɕKvȉ摜Ԃ擾
	static AC_PISTATE GetRequireOfPIState( void )
	{
		return AC_PISB_FILEPATH ;
	}
	// 擾
	UINT GetAttNum( void ) const
	{
		return static_cast<UINT>( m_attNameVec.size() ) ;
	}
	// ̂擾
	LPCSTR GetAttName( UINT index ) const
	{
		try
		{
			return m_attNameVec.at(index).c_str() ;
		}
		catch ( ... )
		{
			return NULL ;
		}
	}
} ;
